#!/usr/bin/env python
from fnmatch import *
from re import match
from sys import *
from isstring import *
from public import *
from tolist import *

@public
def iswildcard(string):
    """Check string is Unix shell-style wildcards

    Returns:
        true if string is pattern, false else
    """
    # https://docs.python.org/2/library/fnmatch.html
    if not string: return False
    if not isstring(string): return False
    if "*" in string: return True
    if "?" in string: return True
    if bool(match('(.*)\[([^]]*)\](.*)',string)):
        # [seq]
        return True
    if bool(match('(.*)\[\!([^]]*)\](.*)',string)):
        # [!seq]
        return True
    return False

if __name__=="__main__":
    print(iswildcard("*")) # True
    print(iswildcard("?")) # True
    print(iswildcard("[123]")) # True
    print(iswildcard("[!123]")) # True
    print(iswildcard("string")) # False
